//+------------------------------------------------------------------+
//|                                                  AscTrend2_2.mq4 |
//|                                     Copyright  2006, Nick Bilak |
//|                 03/26/2008 fixed by Igorad for www.forex-tsd.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, Nick Bilak"




#property  indicator_chart_window
#property  indicator_buffers 2
#property  indicator_color1  LimeGreen
#property  indicator_color2  DarkOrange
#property  indicator_width1  2
#property  indicator_width2  2



extern int    Risk        = 3;
extern double MONYRISK    = 1.5;
extern int    SmoothPhase = 5;
extern int    Price       = 0;




double e1[];
double e2[];
double value9[];
double value10[];
double value4[];
double value5[];
double value6[];

double pointvalue=1;


int init()
  {
  
  if (Digits == 4 || Digits == 2) pointvalue = Point;
   else if (Digits == 5 || Digits == 3) pointvalue = 10.0 * Point;

   
   IndicatorBuffers(7);
   SetIndexBuffer(0,e1);SetIndexStyle(0,DRAW_ARROW);SetIndexArrow(0,159);SetIndexLabel(0,"UpAscTrend");
   SetIndexBuffer(1,e2);SetIndexStyle(1,DRAW_ARROW);SetIndexArrow(1,159);SetIndexLabel(1,"DnAscTrend");
   SetIndexBuffer(2,value9);
   SetIndexBuffer(3,value10);
   SetIndexBuffer(4,value4);
   SetIndexBuffer(5,value5);
   SetIndexBuffer(6,value6);
   
   
   IndicatorShortName("AscTrend2("+Risk+","+DoubleToStr(MONYRISK,2)+")");
   
   return(0);
  }

int start()  
{
   int Counter,TrueCount,MRO1,MRO2,MRO3,MRO4;
   int value3=18+3*Risk;
   int counted_bars=IndicatorCounted();
   int i,limit;

   if(counted_bars<0) return(-1);
   if(counted_bars>0) counted_bars--;
   limit = MathMin(Bars-counted_bars,Bars-1);
         
      
   for(i=limit; i>=0; i--) 
   {
	   if(i<Bars-value3-1)
	   {
	   double Range=0;
	   double AvgRange=0;
	   double AvgRange1=0;
         for (Counter=i; Counter<=i+9; Counter++)
	      { 
	      AvgRange+=MathAbs(High[Counter]-Low[Counter]);
	      AvgRange1+=MathAbs(Close[Counter]-Close[Counter+3]);
	      }
	
      if((High[i] - Low[i]) == 0) Range=AvgRange1/10.0;
	   else Range=AvgRange/10.0;
         
      double value19=MONYRISK*Range;
	   int value2=Risk;
	
   
      double value11 =   iSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i),  9,     SmoothPhase,i,   0);
	   double value12 =   iSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i),  value3,SmoothPhase,i,  10);
	   double value11_1 = iSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i+1),9,     SmoothPhase,i+1,20);
	   double value12_1 = iSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i+1),value3,SmoothPhase,i,  30);
	   double value13=Range;   
	 
	   double AvgRange_1=(High[i]+Low[i])/2.0;
   	if (Close[i+value2]<AvgRange_1) 
      value4[i]=2*AvgRange_1-Low[i+value2];
	   else 
	   value4[i]=2*AvgRange_1-High[i+value2];
	   
	   MRO1=-1;
	   Counter=i+1;
	   TrueCount=0;
         while (Counter<i+3 && TrueCount<1) 
	      {
		
		if (value4[Counter] > value4[Counter+1] && value4[Counter+1] < value4[Counter+2]) TrueCount=TrueCount+1;
		Counter=Counter+1;
		}
	   
      if (TrueCount>=1) MRO1=Counter-(i+1)-1;
	  
	   MRO2=-1;
	   Counter=i+1;
	   TrueCount=0;
         while (Counter<i+3 && TrueCount<1) 
	      {
		   if (value4[Counter] < value4[Counter+1] && value4[Counter+1] > value4[Counter+2]) TrueCount=TrueCount+1; 
		   Counter=Counter+1;
		   }
   
      if (TrueCount>=1) MRO2=Counter-(i+1)-1;
	
      // -----
	   if (value11_1 < value12_1 && value11 > value12) 
      {
	   
         if (Close[i+1]<Low[i]) value5[i]=Close[i+1]-value13;
		   else value5[i]=Low[i]-value13;
	   }
	   else
	   {
         if (MRO1>-1 && Low[i+1] > value4[i+1]) value5[i] = value4[i+1] - value13;
	      else
	      value5[i] = value5[i+1];
	   }
	
	   
	   if (value11_1 > value12_1 && value11 < value12) 
	   {
	
         if (Close[i+1] > High[i]) value6[i]=Close[i+1]+value13;
		   else value6[i] = High[i]+value13;
	   }
	   else
	   {
         if (MRO2>-1 && High[i+1] < value4[i+1]) value6[i] = value4[i+1] + value13;
	      else
	      value6[i] = value6[i+1];
      }	   
	   
	   if (MathAbs(Open[i]-Close[i+1])>=1.618*value13) 
	   {
         if (value11 > value12) value5[i]=Low[i]-value13;
	      if (value11 < value12) value6[i]=High[i]+value13;
	   }
	  
	   if (Low[i]-2.40 * value13 < value9[i+1]) 
	   double value7 = value9[i+1];
	   else 	
	   value7 = Low[i] - 2.40 * value13;
	   
	   if (High[i] + 2.40*value13 > value10[i+1]) 
	   double value8 = value10[i+1];
	   else 
	   value8 = High[i] + 2.40 * value13;
	  
	   if(Low[i] - 0.05*value19 - 10*60*pointvalue > value7) value9[i] = value7;
	   else
	   value9[i] = Low[i] - 0.05*value19 - 10*60*pointvalue;
	  
	   if(High[i] + 0.05*value19 + 10*60*pointvalue < value8) value10[i] = value8;
	   else
	   value10[i] = High[i] + 0.05*value19 + 10*60*pointvalue;
	  
	   if (Low[i]-value9[i] > value19) value9[i]=Low[i]-(1.50+0.1*Risk)*value13;
	  	if (value10[i]-High[i] > value19) value10[i]=High[i]+(1.50+0.1*Risk)*value13;
	
	   if (value11>=value12 && value5[i]>=value9[i]) value9[i]=value5[i];
	   if (value11<=value12 && value6[i]<=value10[i]) value10[i]=value6[i];
	   if (value11<=value12 && value5[i]<=value9[i]) value9[i]=value5[i];
	   if (value11>=value12 && value6[i]>=value10[i]) value10[i]=value6[i];
	   
	   MRO3=-1;
	   Counter=i+1;
	   TrueCount=0;
         while (Counter<i+3 && TrueCount<1) 
         {
		   double value11_3 = iSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,Counter),9,     SmoothPhase,Counter,40);
		   double value12_3 = iSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,Counter),value3,SmoothPhase,Counter,50);
		   if (value11_3>=value12_3) TrueCount=TrueCount+1;
		   Counter=Counter+1;
		   }
	   if (TrueCount>=1) MRO3=Counter-(i+1)-1;
   
	   MRO4=-1;
	   Counter=i+1;
	   TrueCount=0;
         while (Counter<i+3 && TrueCount<1) 
         {
		   double value11_4 = iSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,Counter),9,     SmoothPhase,Counter,60);
		   double value12_4 = iSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,Counter),value3,SmoothPhase,Counter,70);
		   if (value11_4<=value12_4) TrueCount=TrueCount+1;
		   Counter=Counter+1;
		   }
      if (TrueCount>=1) MRO4=Counter-(i+1)-1;
	  
	   if (MRO3>-1 && value9[i]<=value9[i+1] ) value9[i]=value9[i+1];
	   if (MRO4>-1 && value10[i]>=value10[i+1]) value10[i]=value10[i+1];
	
      if (value9[i]>0 && value9[i]<=High[i] && value11>=value12) e1[i]=value9[i];
      else e1[i] = EMPTY_VALUE;
	   if (value10[i]>0 && value10[i]<100000 && value11<value12 && value10[i]>=Low[i]) e2[i]=value10[i];
	   else e2[i] = EMPTY_VALUE;
 
      }
   }
}

    
double wrk[][80];

#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

  
double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (length <=1) return(price);
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[r][k+s]=price; for(; k<10; k++) wrk[r][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

